#!/bin/bash

for f in snorlax sobble rowlet;do
    ssh $f sudo systemctl stop k3s || true
    ssh $f sudo k3s-killall.sh || true
    ssh $f sudo rm -rf /var/lib/rancher/k3s /etc/rancher/k3s
done

deploy() {
    TARGET="$1"
    nixos-rebuild --flake ".#$TARGET" --target-host "$TARGET" switch --impure --use-remote-sudo
}

deploy snorlax
TOKEN="$(ssh snorlax sudo cat /var/lib/rancher/k3s/server/node-token)"
echo "$TOKEN" | ssh sobble "sudo bash -c 'umask 077; cat > /etc/k3s.token'"
echo "$TOKEN" | ssh rowlet "sudo bash -c 'umask 077; cat > /etc/k3s.token'"
deploy sobble
deploy rowlet

import-k3s-creds.sh sobble k0 172.16.1.2

flux bootstrap gitea --hostname=git.strudelline.net --owner=cascade --repository=k0 --token-auth
